## ccls 0.20190314

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
project(ccls LANGUAGES CXX)

option(USE_SYSTEM_RAPIDJSON "Use system RapidJSON instead of the git submodule if exists" ON)

# Sources for the executable are specified at end of CMakeLists.txt
add_executable(ccls "")

### Default build type

set(DEFAULT_CMAKE_BUILD_TYPE Release)

# CMAKE_BUILD_TYPE is not available if a multi-configuration generator is used
# (eg Visual Studio generators)
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to '${DEFAULT_CMAKE_BUILD_TYPE}' as none \
was specified.")
  set(CMAKE_BUILD_TYPE ${DEFAULT_CMAKE_BUILD_TYPE}
      CACHE STRING "Choose the type of build." FORCE)

  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE
               PROPERTY STRINGS Debug Release MinSizeRel RelWithDebInfo)
endif()

### Compile options

# Enable C++17 (Required)
set_property(TARGET ccls PROPERTY CXX_STANDARD 17)
set_property(TARGET ccls PROPERTY CXX_STANDARD_REQUIRED ON)
set_property(TARGET ccls PROPERTY CXX_EXTENSIONS OFF)

# CMake sets MSVC for both MSVC and Clang(Windows)
if(MSVC)
  # Common MSVC/Clang(Windows) options
  target_compile_options(ccls PRIVATE
    /nologo
    /EHsc
    /D_CRT_SECURE_NO_WARNINGS # don't try to use MSVC std replacements
    /W3 # roughly -Wall
    /wd4996 # ignore deprecated declaration
    /wd4267 # ignores warning C4267
            # (conversion from 'size_t' to 'type'),
            # roughly -Wno-sign-compare
    /wd4800
    /wd4068 # Disable unknown pragma warning
    /std:c++17
    $<$<CONFIG:Debug>:/FS>
  )
  # relink system libs
  target_link_libraries(ccls PRIVATE Mincore.lib)
else()
  # Common GCC/Clang(Linux) options
  target_compile_options(ccls PRIVATE
                         -Wall
                         -Wno-sign-compare
                         )

  if(${CMAKE_CXX_COMPILER_ID} STREQUAL GNU)
    target_compile_options(ccls PRIVATE -Wno-return-type -Wno-unused-result)
  endif()

  if(${CMAKE_CXX_COMPILER_ID} STREQUAL Clang)
    target_compile_options(ccls PRIVATE
                           $<$<CONFIG:Debug>:-fno-limit-debug-info>)
  endif()
endif()

### Libraries

find_package(Clang REQUIRED)

target_link_libraries(ccls PRIVATE
  clangIndex
  clangFormat
  clangTooling
  clangToolingInclusions
  clangToolingCore
  clangFrontend
  clangParse
  clangSerialization
  clangSema
  clangAST
  clangLex
  clangDriver
  clangBasic
)

if(LLVM_LINK_LLVM_DYLIB)
  target_link_libraries(ccls PRIVATE LLVM)
else()
  # In llvm 7, clangDriver headers reference LLVMOption
  target_link_libraries(ccls PRIVATE LLVMOption LLVMSupport)
endif()

if(NOT LLVM_ENABLE_RTTI)
  # releases.llvm.org libraries are compiled with -fno-rtti
  # The mismatch between lib{clang,LLVM}* and ccls can make libstdc++ std::make_shared return nullptr
  # _Sp_counted_ptr_inplace::_M_get_deleter
  if(MSVC)
    target_compile_options(ccls PRIVATE /GR-)
  else()
    target_compile_options(ccls PRIVATE -fno-rtti)
  endif()
endif()

# Enable threading support
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)
target_link_libraries(ccls PRIVATE Threads::Threads)

if(${CMAKE_SYSTEM_NAME} STREQUAL FreeBSD)
  find_package(Backtrace REQUIRED)
  target_link_libraries(ccls PRIVATE ${Backtrace_LIBRARIES})
  # src/platform_posix.cc uses libthr
  target_link_libraries(ccls PRIVATE thr)
endif()

### Definitions

# Find Clang resource directory with Clang executable.

find_program(CLANG_EXECUTABLE clang)
if(NOT CLANG_EXECUTABLE)
  message(FATAL_ERROR "clang executable not found.")
endif()

execute_process(
  COMMAND ${CLANG_EXECUTABLE} -print-resource-dir
  RESULT_VARIABLE CLANG_FIND_RESOURCE_DIR_RESULT
  OUTPUT_VARIABLE CLANG_RESOURCE_DIR
  ERROR_VARIABLE CLANG_FIND_RESOURCE_DIR_ERROR
  OUTPUT_STRIP_TRAILING_WHITESPACE
)

if(CLANG_FIND_RESOURCE_DIR_RESULT)
  message(FATAL_ERROR "Error retrieving Clang resource directory with Clang \
          executable. Output:\n ${CLANG_FIND_RESOURCE_DIR_ERROR}")
endif()

set_property(SOURCE src/utils.cc APPEND PROPERTY COMPILE_DEFINITIONS
             CLANG_RESOURCE_DIRECTORY=R"\(${CLANG_RESOURCE_DIR}\)")

### Includes

target_include_directories(ccls PRIVATE src)
target_include_directories(ccls SYSTEM PRIVATE
  third_party ${LLVM_INCLUDE_DIRS} ${CLANG_INCLUDE_DIRS})

if(USE_SYSTEM_RAPIDJSON)
  find_package(RapidJSON QUIET)
endif()
if(NOT RapidJSON_FOUND)
  set(RapidJSON_INCLUDE_DIRS third_party/rapidjson/include)
endif()
target_include_directories(ccls SYSTEM PRIVATE ${RapidJSON_INCLUDE_DIRS})

### Install

install(TARGETS ccls RUNTIME DESTINATION bin)

### Sources

target_sources(ccls PRIVATE third_party/siphash.cc)

target_sources(ccls PRIVATE
  src/clang_tu.cc
  src/config.cc
  src/filesystem.cc
  src/fuzzy_match.cc
  src/main.cc
  src/include_complete.cc
  src/indexer.cc
  src/log.cc
  src/lsp.cc
  src/message_handler.cc
  src/pipeline.cc
  src/platform_posix.cc
  src/platform_win.cc
  src/position.cc
  src/project.cc
  src/query.cc
  src/sema_manager.cc
  src/serializer.cc
  src/test.cc
  src/utils.cc
  src/working_files.cc
)

target_sources(ccls PRIVATE
  src/messages/ccls_call.cc
  src/messages/ccls_info.cc
  src/messages/ccls_inheritance.cc
  src/messages/ccls_member.cc
  src/messages/ccls_navigate.cc
  src/messages/ccls_reload.cc
  src/messages/ccls_vars.cc
  src/messages/initialize.cc
  src/messages/textDocument_code.cc
  src/messages/textDocument_completion.cc
  src/messages/textDocument_definition.cc
  src/messages/textDocument_did.cc
  src/messages/textDocument_foldingRange.cc
  src/messages/textDocument_formatting.cc
  src/messages/textDocument_document.cc
  src/messages/textDocument_hover.cc
  src/messages/textDocument_references.cc
  src/messages/textDocument_rename.cc
  src/messages/textDocument_signatureHelp.cc
  src/messages/workspace.cc
)

### Obtain CCLS version information from Git
### This only happens when cmake is re-run!

if(NOT CCLS_VERSION)
  execute_process(COMMAND git describe --tag --long HEAD
    OUTPUT_VARIABLE CCLS_VERSION
    OUTPUT_STRIP_TRAILING_WHITESPACE
    WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}")

  if(NOT CCLS_VERSION)
    set(CCLS_VERSION "<unknown>")
  endif()
endif()

set_property(SOURCE src/main.cc APPEND PROPERTY
             COMPILE_DEFINITIONS CCLS_VERSION=\"${CCLS_VERSION}\")

=== debian/changelog ===
ccls (0.20190314-1) unstable; urgency=medium

  * Initial release (Closes: #926499)

 -- Shengjing Zhu <zhsj@debian.org>  Fri, 05 Apr 2019 22:35:31 +0800

=== debian/control ===
Source: ccls
Section: devel
Priority: optional
Maintainer: Shengjing Zhu <zhsj@debian.org>
Build-Depends:
 clang,
 cmake,
 debhelper-compat (= 12),
 libclang-dev,
 llvm-dev,
 rapidjson-dev,
Standards-Version: 4.3.0
Homepage: https://github.com/MaskRay/ccls
Vcs-Browser: https://salsa.debian.org/zhsj/ccls
Vcs-Git: https://salsa.debian.org/zhsj/ccls.git

Package: ccls
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 elpa-lsp-mode,
Description: C/C++/ObjC language server
 This originates from cquery, and supports:
 .
  * code completion (with both signature help and snippets)
  * definition/references, and other cross references
  * cross reference extensions:
    $ccls/call $ccls/inheritance $ccls/member $ccls/vars ...
  * formatting
  * hierarchies:
    call (caller/callee) hierarchy, inheritance (base/derived) hierarchy,
    member hierarchy
  * symbol rename
  * document symbols and approximate search of workspace symbol
  * hover information
  * diagnostics and code actions (clang FixIts)
  * semantic highlighting and preprocessor skipped regions
  * semantic navigation:
    $ccls/navigate

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/default.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCCLS_VERSION=$(DEB_VERSION)

## ccls 0.20190823

=== debian/changelog ===
ccls (0.20190823-4ubuntu1) eoan; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - stick with llvm-8 (thanks to Shengjing Zhu for the d/rules fix)
      LP: #1845233

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 24 Sep 2019 18:46:36 +0200

ccls (0.20190823-4) unstable; urgency=medium

  * Rebuild against clang-8 and llvm-8

 -- Shengjing Zhu <zhsj@debian.org>  Tue, 24 Sep 2019 22:32:57 +0800

ccls (0.20190823-3ubuntu3) eoan; urgency=medium

  * Stick with llvm-8 for now

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 03 Sep 2019 12:46:52 +0200

ccls (0.20190823-3) unstable; urgency=medium

  * debian/rules: drop libatomic hack (didn't work)
    Although it can compile, the result binary crashes at runtime
  * debian/rules: also run testcase from autopkgtest when building

 -- Shengjing Zhu <zhsj@debian.org>  Tue, 27 Aug 2019 00:23:22 +0800

ccls (0.20190823-2) unstable; urgency=medium

  * autopkgtest: fix testdata for new version.
    Add declarationProvider in expected response

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 26 Aug 2019 03:17:39 +0800

ccls (0.20190823-1) unstable; urgency=medium

  * New upstream release 0.20190823
    + [aded3fa] ignore non-object initializationOptions (Closes: #934881)
  * debian/control: set Rules-Requires-Root to no
  * debian/control: update Standards-Version to 4.4.0 (no changes)
  * Drop patch applied in upstream

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 26 Aug 2019 01:10:22 +0800

ccls (0.20190314.1-2) unstable; urgency=medium

  * debian/tests: refactor test case
  * debian/rules: set CLANG_RESOURCE_DIR to /usr/include/clang/*
    And recommends libclang-common-*-dev

 -- Shengjing Zhu <zhsj@debian.org>  Sun, 11 Aug 2019 19:45:33 +0800

ccls (0.20190314.1-1) unstable; urgency=medium

  * New upstream release
  * debian/copyright: remove duplicate file entries
  * debian/rules: link libatomic on some 32bit architectures

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 10 Aug 2019 16:52:21 +0800

=== debian/control ===
--- 
+++ 
@@ -2,14 +2,16 @@
 Section: devel
 Priority: optional
 Maintainer: Shengjing Zhu <zhsj@debian.org>
+Rules-Requires-Root: no
 Build-Depends:
- clang,
+ clang-8,
  cmake,
  debhelper-compat (= 12),
- libclang-dev,
- llvm-dev,
+ libclang-8-dev,
+ llvm-8-dev,
+ python3,
  rapidjson-dev,
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Homepage: https://github.com/MaskRay/ccls
 Vcs-Browser: https://salsa.debian.org/zhsj/ccls
 Vcs-Git: https://salsa.debian.org/zhsj/ccls.git
@@ -19,6 +21,8 @@
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
+Recommends:
+ ${ccls:Recommends},
 Suggests:
  elpa-lsp-mode,
 Description: C/C++/ObjC language server

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/default.mk

CLANG_VER := 8
#CLANG_VER := $(shell realpath /usr/bin/clang | sed -e 's/.*llvm-\([0-9]\+\).*/\1/')
CLANG_RESOURCE_DIR := /usr/include/clang/$(CLANG_VER)
CCLS_SUBSTVARS += -Vccls:Recommends=$(shell dpkg-query -S $(CLANG_RESOURCE_DIR) | sed -e 's/: .*//')

CMAKE_OPTS += -DCCLS_VERSION=$(DEB_VERSION)
CMAKE_OPTS += -DCLANG_RESOURCE_DIR=$(CLANG_RESOURCE_DIR)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_OPTS)

override_dh_gencontrol:
	dh_gencontrol -- $(CCLS_SUBSTVARS)

# upstream tests need building with clang-6, but we don't
override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	CCLS=obj-$(DEB_HOST_GNU_TYPE)/ccls debian/tests/lsp-test
	rm -rf debian/tests/.ccls-cache
endif

## ccls 0.20190823.3

=== debian/changelog ===
ccls (0.20190823.3-1ubuntu1) focal; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - stick with llvm-8 for now

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 26 Oct 2019 10:58:51 +0200

ccls (0.20190823.3-1) unstable; urgency=medium

  * New upstream release 0.20190823.3
  * debian/control: minor change for package description
  * debian/rules: python3 is only needed for test
  * debian/rules: guess clang version by directory name
  * Bump Standards-Version to 4.4.1 (no changes)

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 23 Oct 2019 03:33:02 +0800

## ccls 0.20190823.4

=== debian/changelog ===
ccls (0.20190823.4-1ubuntu1) focal; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - stick with llvm-8 (thanks to Shengjing Zhu for the d/rules fix)
      LP: #1845233

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 29 Oct 2019 06:30:48 +0100

ccls (0.20190823.4-1) unstable; urgency=medium

  * New upstream release 0.20190823.4

 -- Shengjing Zhu <zhsj@debian.org>  Sun, 27 Oct 2019 01:38:08 +0800

=== debian/control ===
--- 
+++ 
@@ -9,9 +9,9 @@
  debhelper-compat (= 12),
  libclang-8-dev,
  llvm-8-dev,
- python3,
+ python3 <!nocheck>,
  rapidjson-dev,
-Standards-Version: 4.4.0
+Standards-Version: 4.4.1
 Homepage: https://github.com/MaskRay/ccls
 Vcs-Browser: https://salsa.debian.org/zhsj/ccls
 Vcs-Git: https://salsa.debian.org/zhsj/ccls.git
@@ -26,7 +26,8 @@
 Suggests:
  elpa-lsp-mode,
 Description: C/C++/ObjC language server
- This originates from cquery, and supports:
+ This originates from cquery, and is a server implementing
+ Language Server Protocol for C/C++/Objective-C. It supports:
  .
   * code completion (with both signature help and snippets)
   * definition/references, and other cross references

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 include /usr/share/dpkg/default.mk
 
 CLANG_VER := 8
-#CLANG_VER := $(shell realpath /usr/bin/clang | sed -e 's/.*llvm-\([0-9]\+\).*/\1/')
+#CLANG_VER := $(shell ls /usr/include/clang | grep '^[0-9]\+$$'| head -n 1)
 CLANG_RESOURCE_DIR := /usr/include/clang/$(CLANG_VER)
 CCLS_SUBSTVARS += -Vccls:Recommends=$(shell dpkg-query -S $(CLANG_RESOURCE_DIR) | sed -e 's/: .*//')

## ccls 0.20190823.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -120,22 +120,24 @@
 
 # Find Clang resource directory with Clang executable.
 
-find_program(CLANG_EXECUTABLE clang)
-if(NOT CLANG_EXECUTABLE)
-  message(FATAL_ERROR "clang executable not found.")
-endif()
-
-execute_process(
-  COMMAND ${CLANG_EXECUTABLE} -print-resource-dir
-  RESULT_VARIABLE CLANG_FIND_RESOURCE_DIR_RESULT
-  OUTPUT_VARIABLE CLANG_RESOURCE_DIR
-  ERROR_VARIABLE CLANG_FIND_RESOURCE_DIR_ERROR
-  OUTPUT_STRIP_TRAILING_WHITESPACE
-)
-
-if(CLANG_FIND_RESOURCE_DIR_RESULT)
-  message(FATAL_ERROR "Error retrieving Clang resource directory with Clang \
-          executable. Output:\n ${CLANG_FIND_RESOURCE_DIR_ERROR}")
+if(NOT CLANG_RESOURCE_DIR)
+  find_program(CLANG_EXECUTABLE clang)
+  if(NOT CLANG_EXECUTABLE)
+    message(FATAL_ERROR "clang executable not found.")
+  endif()
+
+  execute_process(
+    COMMAND ${CLANG_EXECUTABLE} -print-resource-dir
+    RESULT_VARIABLE CLANG_FIND_RESOURCE_DIR_RESULT
+    OUTPUT_VARIABLE CLANG_RESOURCE_DIR
+    ERROR_VARIABLE CLANG_FIND_RESOURCE_DIR_ERROR
+    OUTPUT_STRIP_TRAILING_WHITESPACE
+  )
+
+  if(CLANG_FIND_RESOURCE_DIR_RESULT)
+    message(FATAL_ERROR "Error retrieving Clang resource directory with Clang \
+            executable. Output:\n ${CLANG_FIND_RESOURCE_DIR_ERROR}")
+  endif()
 endif()
 
 set_property(SOURCE src/utils.cc APPEND PROPERTY COMPILE_DEFINITIONS
@@ -143,17 +145,25 @@
 
 ### Includes
 
-target_include_directories(ccls PRIVATE src)
-target_include_directories(ccls SYSTEM PRIVATE
-  third_party ${LLVM_INCLUDE_DIRS} ${CLANG_INCLUDE_DIRS})
-
 if(USE_SYSTEM_RAPIDJSON)
   find_package(RapidJSON QUIET)
 endif()
 if(NOT RapidJSON_FOUND)
   set(RapidJSON_INCLUDE_DIRS third_party/rapidjson/include)
 endif()
-target_include_directories(ccls SYSTEM PRIVATE ${RapidJSON_INCLUDE_DIRS})
+
+target_include_directories(ccls PRIVATE src)
+
+foreach(include_dir third_party
+    ${LLVM_INCLUDE_DIRS} ${CLANG_INCLUDE_DIRS} ${RapidJSON_INCLUDE_DIRS})
+  get_filename_component(include_dir_realpath ${include_dir} REALPATH)
+  # Don't add as SYSTEM if they are in CMAKE_CXX_IMPLICIT_INCLUDE_DIRECTORIES.
+  # It would reorder the system search paths and cause issues with libstdc++'s
+  # use of #include_next. See https://github.com/MaskRay/ccls/pull/417
+  if(NOT "${include_dir_realpath}" IN_LIST CMAKE_CXX_IMPLICIT_INCLUDE_DIRECTORIES)
+    target_include_directories(ccls SYSTEM PRIVATE ${include_dir})
+  endif()
+endforeach()
 
 ### Install

=== debian/changelog ===
ccls (0.20190823.5-1) unstable; urgency=medium

  * New upstream release 0.20190823.5

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 13 Nov 2019 00:25:32 +0800

=== debian/control ===
--- 
+++ 
@@ -4,11 +4,11 @@
 Maintainer: Shengjing Zhu <zhsj@debian.org>
 Rules-Requires-Root: no
 Build-Depends:
- clang-8,
+ clang,
  cmake,
  debhelper-compat (= 12),
- libclang-8-dev,
- llvm-8-dev,
+ libclang-dev,
+ llvm-dev,
  python3 <!nocheck>,
  rapidjson-dev,
 Standards-Version: 4.4.1

=== debian/watch ===
version=4
https://github.com/MaskRay/ccls/releases (?:.*/)?v?(\d[\d\.]+)\.tar\.gz

## ccls 0.20190823.6

=== debian/changelog ===
ccls (0.20190823.6-1~ubuntu1.20.04.1) focal; urgency=medium

  * SRU the bugfix release to make it compatible with default llvm-10
    fixing a FTBFS (LP: #1874508)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 12 Jun 2020 22:31:35 +0200

ccls (0.20190823.6-1) unstable; urgency=medium

  * New upstream release 0.20190823.6
  * Update Standards-Version to 4.5.0 (no changes)
  * Run ccls index in autopkgtest

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 22 Apr 2020 15:03:08 +0800

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  llvm-dev,
  python3 <!nocheck>,
  rapidjson-dev,
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Homepage: https://github.com/MaskRay/ccls
 Vcs-Browser: https://salsa.debian.org/zhsj/ccls
 Vcs-Git: https://salsa.debian.org/zhsj/ccls.git

=== debian/rules ===
--- 
+++ 
@@ -4,8 +4,7 @@
 
 include /usr/share/dpkg/default.mk
 
-CLANG_VER := 8
-#CLANG_VER := $(shell ls /usr/include/clang | grep '^[0-9]\+$$'| head -n 1)
+CLANG_VER := $(shell ls /usr/include/clang | grep '^[0-9]\+$$'| head -n 1)
 CLANG_RESOURCE_DIR := /usr/include/clang/$(CLANG_VER)
 CCLS_SUBSTVARS += -Vccls:Recommends=$(shell dpkg-query -S $(CLANG_RESOURCE_DIR) | sed -e 's/: .*//')

=== debian/tests/control ===
Tests: lsp-test
Depends:
 python3,
 @,

## ccls 0.20201025

=== CMakeLists.txt ===
--- 
+++ 
@@ -70,21 +70,25 @@
 
 find_package(Clang REQUIRED)
 
-target_link_libraries(ccls PRIVATE
-  clangIndex
-  clangFormat
-  clangTooling
-  clangToolingInclusions
-  clangToolingCore
-  clangFrontend
-  clangParse
-  clangSerialization
-  clangSema
-  clangAST
-  clangLex
-  clangDriver
-  clangBasic
-)
+if(CLANG_LINK_CLANG_DYLIB)
+  target_link_libraries(ccls PRIVATE clang-cpp)
+else()
+  target_link_libraries(ccls PRIVATE
+    clangIndex
+    clangFormat
+    clangTooling
+    clangToolingInclusions
+    clangToolingCore
+    clangFrontend
+    clangParse
+    clangSerialization
+    clangSema
+    clangAST
+    clangLex
+    clangDriver
+    clangBasic
+  )
+endif()
 
 if(LLVM_LINK_LLVM_DYLIB)
   target_link_libraries(ccls PRIVATE LLVM)
@@ -116,6 +120,10 @@
   target_link_libraries(ccls PRIVATE thr)
 endif()
 
+if(LLVM_ENABLE_ZLIB)
+  find_package(ZLIB)
+endif()
+
 ### Definitions
 
 # Find Clang resource directory with Clang executable.
@@ -146,10 +154,21 @@
 ### Includes
 
 if(USE_SYSTEM_RAPIDJSON)
-  find_package(RapidJSON QUIET)
+  set(RapidJSON_MIN_VERSION "1.1.0")
+  find_package(RapidJSON ${RapidJSON_MIN_VERSION} QUIET)
+  if(NOT DEFINED RapidJSON_INCLUDE_DIRS AND DEFINED RAPIDJSON_INCLUDE_DIRS)
+    set(RapidJSON_INCLUDE_DIRS "${RAPIDJSON_INCLUDE_DIRS}")
+  endif()
 endif()
 if(NOT RapidJSON_FOUND)
-  set(RapidJSON_INCLUDE_DIRS third_party/rapidjson/include)
+  if(EXISTS "${CMAKE_SOURCE_DIR}/third_party/rapidjson/include")
+    message(STATUS "Using local RapidJSON")
+    set(RapidJSON_INCLUDE_DIRS third_party/rapidjson/include)
+  else()
+    message(STATUS "Plase initialize rapidJSON git submodule as currently installed version is to old:")
+    message(STATUS "git submodule init && git submodule update")
+    message(FATAL_ERROR "RapidJSON version is likely too old. See https://github.com/MaskRay/ccls/issues/455")
+  endif()
 endif()
 
 target_include_directories(ccls PRIVATE src)
@@ -236,3 +255,5 @@
 
 set_property(SOURCE src/main.cc APPEND PROPERTY
              COMPILE_DEFINITIONS CCLS_VERSION=\"${CCLS_VERSION}\")
+set_property(SOURCE src/messages/initialize.cc APPEND PROPERTY
+             COMPILE_DEFINITIONS CCLS_VERSION=\"${CCLS_VERSION}\")

=== debian/changelog ===
ccls (0.20201025-1) unstable; urgency=medium

  * New upstream release 0.20201025
  * Bump debhelper-compat to 13
  * Update autopkgtest cases for new version

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 26 Oct 2020 16:26:47 +0800

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends:
  clang,
  cmake,
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  libclang-dev,
  llvm-dev,
  python3 <!nocheck>,

## ccls 0.20201219

=== debian/changelog ===
ccls (0.20201219-1) unstable; urgency=medium

  * New upstream release 0.20201219

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 23 Dec 2020 13:53:48 +0800

ccls (0.20201025-2) unstable; urgency=medium

  * Fix version detection in autopkgtest (Closes: #976994)
  * Bump Standards-Version to 4.5.1 (no changes)

 -- Shengjing Zhu <zhsj@debian.org>  Thu, 10 Dec 2020 22:55:45 +0800

## ccls 0.20210330

=== CMakeLists.txt ===
--- 
+++ 
@@ -45,6 +45,7 @@
     /wd4800
     /wd4068 # Disable unknown pragma warning
     /std:c++17
+    /Zc:__cplusplus
     $<$<CONFIG:Debug>:/FS>
   )
   # relink system libs

=== debian/changelog ===
ccls (0.20210330-1) unstable; urgency=medium

  * New bugfix release 0.20210330

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 07 Apr 2021 02:02:37 +0800

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  llvm-dev,
  python3 <!nocheck>,
  rapidjson-dev,
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://github.com/MaskRay/ccls
 Vcs-Browser: https://salsa.debian.org/zhsj/ccls
 Vcs-Git: https://salsa.debian.org/zhsj/ccls.git

=== debian/tests/control ===
Tests: lsp-test
Depends:
 python3,
 @,
Restrictions: allow-stderr

## ccls 0.20220729

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.8)
-project(ccls LANGUAGES CXX)
+project(ccls LANGUAGES CXX C)
 
 option(USE_SYSTEM_RAPIDJSON "Use system RapidJSON instead of the git submodule if exists" ON)

=== debian/changelog ===
ccls (0.20220729-2) unstable; urgency=medium

  * Fix uscan watch file
  * Update Standards-Version to 4.6.2 (no changes)
  * Move elpa-lsp-mode to Enhances and add vim-ale

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 28 Jan 2023 23:48:30 +0800

ccls (0.20220729-1) unstable; urgency=medium

  * New upstream release 0.20220729 (Closes: #1016275)
  * Update Standards-Version to 4.6.1 (no changes)

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 30 Jul 2022 02:14:46 +0800

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  llvm-dev,
  python3 <!nocheck>,
  rapidjson-dev,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/MaskRay/ccls
 Vcs-Browser: https://salsa.debian.org/zhsj/ccls
 Vcs-Git: https://salsa.debian.org/zhsj/ccls.git
@@ -23,8 +23,9 @@
  ${shlibs:Depends},
 Recommends:
  ${ccls:Recommends},
-Suggests:
+Enhances:
  elpa-lsp-mode,
+ vim-ale,
 Description: C/C++/ObjC language server
  This originates from cquery, and is a server implementing
  Language Server Protocol for C/C++/Objective-C. It supports:

## ccls 0.20230717

=== debian/changelog ===
ccls (0.20230717-1build2) noble; urgency=medium

  * Rebuild against new llvm-toolchain-17 on riscv64.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 22 Nov 2023 08:46:21 +0100

ccls (0.20230717-1build1) noble; urgency=medium

  * No-change rebuild to build with LLVM 17.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 17 Nov 2023 05:25:39 +0100

ccls (0.20230717-1) unstable; urgency=medium

  * New upstream release 0.20230717
    + Supports LLVM-16 (Closes: #1051860)

 -- Shengjing Zhu <zhsj@debian.org>  Thu, 14 Sep 2023 19:25:36 +0800

## ccls 0.20240202

=== CMakeLists.txt ===
--- 
+++ 
@@ -94,8 +94,10 @@
 if(LLVM_LINK_LLVM_DYLIB)
   target_link_libraries(ccls PRIVATE LLVM)
 else()
-  # In llvm 7, clangDriver headers reference LLVMOption
   target_link_libraries(ccls PRIVATE LLVMOption LLVMSupport)
+  if(LLVM_VERSION_MAJOR GREATER_EQUAL 16) # llvmorg-16-init-15123-gf09cf34d0062
+    target_link_libraries(ccls PRIVATE LLVMTargetParser)
+  endif()
 endif()
 
 if(NOT LLVM_ENABLE_RTTI)

=== debian/changelog ===
ccls (0.20240202-1build1) oracular; urgency=medium

  * No-change rebuild against libllvm18.

 -- Rik Mills <rikmills@kde.org>  Mon, 22 Jul 2024 12:30:43 +0100

ccls (0.20240202-1) unstable; urgency=medium

  * New upstream release 0.20240202
    + Supports LLVM-18

 -- Shengjing Zhu <zhsj@debian.org>  Sun, 21 Apr 2024 00:03:33 +0800

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: ccls
 Section: devel
 Priority: optional
-Maintainer: Shengjing Zhu <zhsj@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Shengjing Zhu <zhsj@debian.org>
 Rules-Requires-Root: no
 Build-Depends:
  clang,

## ccls 0.20240505

=== debian/changelog ===
ccls (0.20240505-1) unstable; urgency=medium

  * New upstream release 0.20240505
    + Supports LLVM-19 (Closes: #1084244)

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 07 Oct 2024 18:54:26 +0800

## ccls 0.20241108

=== debian/changelog ===
ccls (0.20241108-1build1) plucky; urgency=medium

  * No-change rebuild for LLVM 20.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 20 Feb 2025 22:01:41 +0100

ccls (0.20241108-1) unstable; urgency=medium

  * New upstream release 0.20241108
  * Bump Standards-Version to 4.7.0 (no changes)
  * Adapt lsp testcase in autopkgtest

 -- Shengjing Zhu <zhsj@debian.org>  Fri, 15 Nov 2024 06:23:03 +0800

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: ccls
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Shengjing Zhu <zhsj@debian.org>
+Maintainer: Shengjing Zhu <zhsj@debian.org>
 Rules-Requires-Root: no
 Build-Depends:
  clang,
@@ -12,7 +11,7 @@
  llvm-dev,
  python3 <!nocheck>,
  rapidjson-dev,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/MaskRay/ccls
 Vcs-Browser: https://salsa.debian.org/zhsj/ccls
 Vcs-Git: https://salsa.debian.org/zhsj/ccls.git

=== debian/rules ===
--- 
+++ 
@@ -22,7 +22,4 @@
 
 # upstream tests need building with clang-6, but we don't
 override_dh_auto_test:
-ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	CCLS=obj-$(DEB_HOST_GNU_TYPE)/ccls debian/tests/lsp-test
-	rm -rf debian/tests/.ccls-cache
-endif

## ccls 0.20250815

=== CMakeLists.txt ===
--- 
+++ 
@@ -201,7 +201,6 @@
   src/filesystem.cc
   src/fuzzy_match.cc
   src/main.cc
-  src/include_complete.cc
   src/indexer.cc
   src/log.cc
   src/lsp.cc

=== debian/changelog ===
ccls (0.20250815-0ubuntu1) resolute; urgency=medium

  * New upstream version.
  * Ignore test results for a first build.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 26 Oct 2025 11:13:52 +0100

=== debian/rules ===
--- 
+++ 
@@ -22,4 +22,4 @@
 
 # upstream tests need building with clang-6, but we don't
 override_dh_auto_test:
-	CCLS=obj-$(DEB_HOST_GNU_TYPE)/ccls debian/tests/lsp-test
+	-CCLS=obj-$(DEB_HOST_GNU_TYPE)/ccls debian/tests/lsp-test

=== debian/watch ===
version=4
https://github.com/MaskRay/ccls/tags (?:.*/)?v?(\d[\d\.]+)\.tar\.gz

## ccls 0.20250815.1

=== debian/changelog ===
ccls (0.20250815.1-1) unstable; urgency=medium

  * New upstream release 0.20250815.1
  * Bump Standards-Version to 4.7.3 (no changes)
    + Supports LLVM-21 (Closes: #1122607)

 -- Shengjing Zhu <zhsj@debian.org>  Thu, 22 Jan 2026 22:30:22 +0800

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  llvm-dev,
  python3 <!nocheck>,
  rapidjson-dev,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Homepage: https://github.com/MaskRay/ccls
 Vcs-Browser: https://salsa.debian.org/zhsj/ccls
 Vcs-Git: https://salsa.debian.org/zhsj/ccls.git
